import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.io.*;
import java.net.*;
import java.nio.charset.*;
import java.nio.file.*;
import java.util.*;
import java.util.prefs.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.text.*;

import javax.swing.text.Highlighter.HighlightPainter;

//-------------------------------------
public class jtxt extends JFrame implements WindowListener {

static jtxt   mf;
static String fto;

JButton       sbar;
JScrollPane   spta;
JTextArea     txta;

boolean       nsav;
File          fil;
Font          taf, uif;
int           maxx, maxy, winx, winy;
int           tafs, uifs, wxp, wyp;
int           selb, sele;
String        fnds, reps, stxt, tafn, uifn, wdir;

static final int  UIFSIZ = 32;
static final int  TAFSIZ = 20;
static final int  WXP    = 50;
static final int  WYP    = 50;
static final String UIFNLIT = "UIFN";
static final String UIFSLIT = "UIFS";
static final String TAFNLIT = "TAFN";
static final String TAFSLIT = "TAFS";
static final String WXPLIT = "WXP";
static final String WYPLIT = "WYP";
static final String DEFDIR  = "C:\\";
static final String DIRKEY  = "WRKDIR";
static final String APPNAM  = "jtxt";

//-------------------------------------
class AEdit implements ActionListener {
public void actionPerformed(ActionEvent fae) {
JMenuItem     mi;
JPopupMenu    pum;
  pum = new JPopupMenu();
  mi = new JMenuItem("Copy");
  mi.setMnemonic('C');
  mi.addActionListener(new AEditCopy());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("Cut");
  mi.setMnemonic('u');
  mi.addActionListener(new AEditCut());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("Paste");
  mi.setMnemonic('P');
  mi.addActionListener(new AEditPaste());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("Select");
  mi.setMnemonic('S');
  mi.addActionListener(new AEditSelect());
  mi.setFont(uif);
  pum.add(mi);
  pum.show(mf, 0, 0);
}}

//-------------------------------------
class AEditCopy implements ActionListener {
public void actionPerformed(ActionEvent sae) {
  txta.copy();
  selb = -1;
  sele = -1;
}}

//-------------------------------------
class AEditCut implements ActionListener {
public void actionPerformed(ActionEvent sae) {
  txta.cut();
  selb = -1;
  sele = -1;
}}

//-------------------------------------
class AEditPaste implements ActionListener {
public void actionPerformed(ActionEvent sae) {
  txta.paste();
  selb = -1;
  sele = -1;
}}

//-------------------------------------
class AEditSelect implements ActionListener {
public void actionPerformed(ActionEvent sae) {
JMenuItem     mi;
JPopupMenu    pum;
  pum = new JPopupMenu();
  mi = new JMenuItem("All");
  mi.setMnemonic('A');
  mi.addActionListener(new AEditSelectAll());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("Begin");
  mi.setMnemonic('B');
  mi.addActionListener(new AEditSelectBegin());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("End");
  mi.setMnemonic('E');
  mi.addActionListener(new AEditSelectEnd());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("None");
  mi.setMnemonic('N');
  mi.addActionListener(new AEditSelectNone());
  mi.setFont(uif);
  pum.add(mi);
  pum.show(mf, 0, 0);
}}

//-------------------------------------
class AEditSelectAll implements ActionListener {
public void actionPerformed(ActionEvent sae) {
  txta.selectAll();
  selb = txta.getSelectionStart();
  sele = txta.getSelectionEnd();
  txta.requestFocusInWindow();
}}

//-------------------------------------
class AEditSelectBegin implements ActionListener {
public void actionPerformed(ActionEvent sae) {
  selb = txta.getCaretPosition();
  if (sele!=-1) {
    txta.setSelectionStart(selb);
    txta.setSelectionEnd(sele);
    txta.requestFocusInWindow();
  }
}}

//-------------------------------------
class AEditSelectEnd implements ActionListener {
public void actionPerformed(ActionEvent sae) {
  sele = txta.getCaretPosition();
  if (selb!=-1) {
    txta.setSelectionStart(selb);
    txta.setSelectionEnd(sele);
    txta.requestFocusInWindow();
  }
}}

//-------------------------------------
class AEditSelectNone implements ActionListener {
public void actionPerformed(ActionEvent sae) {
Highlighter hl;
int         sel;
  selb = -1;
  sele = -1;
  sel = txta.getCaretPosition();
  txta.select(sel, sel);
  txta.requestFocusInWindow();
  hl = txta.getHighlighter();
  hl.removeAllHighlights();
}}

//-------------------------------------
class AFile implements ActionListener {
public void actionPerformed(ActionEvent fae) {
JMenuItem     mi;
JPopupMenu    pum;
  pum = new JPopupMenu();
  mi = new JMenuItem("Open");
  mi.setMnemonic('O');
  mi.addActionListener(new AFileOpen());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("Save");
  mi.setMnemonic('S');
  mi.addActionListener(new AFileSave());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("saveAs");
  mi.setMnemonic('A');
  mi.addActionListener(new AFileSaveAs());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("New");
  mi.setMnemonic('N');
  mi.addActionListener(new AFileNew());
  mi.setFont(uif);
  pum.add(mi);
  pum.show(mf, 0, 0);
}}

//-------------------------------------
class AFileNew implements ActionListener {
public void actionPerformed(ActionEvent fnae) {
String  s;
  fil = null;
  txta.setText("");
  sbar.setText("NewFile");
  mf.setTitle("");
}}

//-------------------------------------
class AFileOpen implements ActionListener {
public void actionPerformed(ActionEvent foae) {
int             fsts;
JFileChooser    fc;
String          fn;
  fc = new JFileChooser(wdir);
  fc.setPreferredSize(new Dimension((maxx*80)/100, (maxy*90)/100));
  fsts = fc.showOpenDialog(mf);
  if (fsts == JFileChooser.APPROVE_OPTION) {
    fil = fc.getSelectedFile();
    wdir = fil.getPath();
    SetPreferences();
    fn = fil.getName();
    mf.setTitle(fn);
    OpenFile();
  }
}}

//-------------------------------------
class AFileSave implements ActionListener {
public void actionPerformed(ActionEvent fsae) {
  SaveFile();
}}

//-------------------------------------
class AFileSaveAs implements ActionListener {
public void actionPerformed(ActionEvent fsaae) {
File  f;
  f = GetFileToSave();
  if (f!=null) {
    fil = f;
    SaveFile();
  }
}}

//-------------------------------------
class AMinimize implements ActionListener {
public void actionPerformed(ActionEvent qae) {
  mf.setState(Frame.ICONIFIED);
}}

//-------------------------------------
class AQuit implements ActionListener {
public void actionPerformed(ActionEvent qae) {
  if (nsav) SaveFile();
  System.exit(0);
}}

//-------------------------------------
class ASearch implements ActionListener {
public void actionPerformed(ActionEvent sae) {
JMenuItem     mi;
JPopupMenu    pum;
  pum = new JPopupMenu();
  mi = new JMenuItem("Find");
  mi.setMnemonic('F');
  mi.addActionListener(new ASearchFind());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("Next");
  mi.setMnemonic('N');
  mi.addActionListener(new ASearchNext());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("Replace");
  mi.setMnemonic('R');
  mi.addActionListener(new ASearchReplace());
  mi.setFont(uif);
  pum.add(mi);
  pum.show(mf, 0, 0);
}}

//-------------------------------------
class ASearchFind implements ActionListener {
public void actionPerformed(ActionEvent sfae) {
  fnds = JOptionPane.showInputDialog(mf, "Find");
  fnds = fnds.toLowerCase();
  SearchNext();
}}

//-------------------------------------
class ASearchNext implements ActionListener {
public void actionPerformed(ActionEvent snae) {
  SearchNext();
}}

//-------------------------------------
class ASearchReplace implements ActionListener {
public void actionPerformed(ActionEvent snae) {
boolean keepon;
int     todo;
  fnds = JOptionPane.showInputDialog(mf, "Find");
  fnds = fnds.toLowerCase();
  reps = JOptionPane.showInputDialog(mf, "Replace");
  do {
    keepon = SearchNext();
    if (keepon) {
      todo = JOptionPane.showConfirmDialog(mf, "Replace?", "Replace?", JOptionPane.YES_NO_OPTION);
      if (todo==JOptionPane.YES_OPTION) txta.replaceSelection(reps); 
    }
  } while (keepon);
}}

//-------------------------------------
class AUtility implements ActionListener {
public void actionPerformed(ActionEvent fae) {
JMenuItem     mi;
JPopupMenu    pum;
  pum = new JPopupMenu();
  mi = new JMenuItem("Count words");
  mi.setMnemonic('C');
  mi.addActionListener(new AUtilityCount());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("Linux");
  mi.setMnemonic('L');
  mi.addActionListener(new AUtilityLinux());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("ParagraphTags");
  mi.setMnemonic('P');
  mi.addActionListener(new AUtilityParagraph());
  mi.setFont(uif);
  pum.add(mi);
  pum.show(mf, 0, 0);
}}

//-------------------------------------
class AUtilityCount implements ActionListener {
public void actionPerformed(ActionEvent fae) {
int       nw;
String    msg, txt;
String[]  sa;
  txt = txta.getText();
  sa = txt.split(" ");
  nw = sa.length;
  msg = String.format("NumberWords = %d", nw);
  Util.DspMsg(msg, mf);
}}

//-------------------------------------
class AUtilityLinux implements ActionListener {
public void actionPerformed(ActionEvent fae) {
int       i, nl;
String    chk, lin, ntxt, txt;
String[]  sa;
  txt = txta.getText();
  sa = txt.split("\r\n");
  nl = sa.length;
  i = 0;
  ntxt = "";
  while (i < nl) {
    lin = sa[i++];
    ntxt += lin;
    ntxt += "\n";
  }
  txta.setText(ntxt);
}}

//-------------------------------------
class AUtilityParagraph implements ActionListener {
public void actionPerformed(ActionEvent fae) {
int       i, nl;
String    chk, lin, ntxt, txt;
String[]  sa;
  txt = txta.getText();
  sa = txt.split("\n");
  nl = sa.length;
  if (nl<3) return;
  i = 0;
  lin = sa[i++];
  ntxt = "<p>\n" + lin;
  while (i < nl) {
    lin = sa[i++];
    chk = lin.trim();
    if (chk.length()>0) {
      ntxt += " ";
      ntxt += lin;
    } else ntxt += "\n</p>\n\n<p>\n";
  }
  txta.setText(ntxt);
}}

//-------------------------------------
class CBButton implements ActionListener {
public void actionPerformed(ActionEvent cbae) {
  PopupMain();
}}

//-------------------------------------
class CBClick extends MouseAdapter {
public void mouseClicked(MouseEvent me) {
   PopupMain();
}}

//-------------------------------------
class CBKey extends KeyAdapter {
public void keyPressed(KeyEvent ke) {
int   kc;
  kc = ke.getKeyCode();
  if (kc == KeyEvent.VK_F1) PopupMain();
  if (kc == KeyEvent.VK_F3) SearchNext();
}}

//-------------------------------------
class CBModified implements DocumentListener {
  public void insertUpdate(DocumentEvent e) { nsav = true; }
  public void removeUpdate(DocumentEvent e) { nsav = true; }
  public void changedUpdate(DocumentEvent e) { nsav = true; }
}

//-------------------------------------
class CBPosition implements CaretListener {
public void caretUpdate(CaretEvent e) {
int     col, i, lin, lnl, pos;
String  txt;
  pos = e.getDot();
  txt = txta.getText();
  lin = 1;
  lnl = 0;
  for(i=0; i<pos; i++) {
    if (txt.charAt(i)==0x0A) {
      lin++;
      lnl = i;
    }
  }
  col = pos-lnl;
  sbar.setText("Line: "+lin+" Column: "+col);
}}

//-------------------------------------
class CBResize extends ComponentAdapter {
public void componentResized(ComponentEvent ce) {
Insets  is;
  winx = getWidth();
  winy = getHeight();
  is = mf.getInsets();
  winx -= (is.left+is.right);
  winy -= (is.top+is.bottom);
}}

//-------------------------------------
File GetFileToSave() {
File          f;
int           fsts;
JFileChooser  fc;
  f = null;
  fc = new JFileChooser(wdir);
  fc.setPreferredSize(new Dimension((maxx*80)/100, (maxy*90)/100));
  fsts = fc.showSaveDialog(mf);
  if (fsts == JFileChooser.APPROVE_OPTION) {
    f = fc.getSelectedFile();
    wdir = f.getPath();
  }
  return(f);
}

//-------------------------------------
void Initlz() {
  InitlzVars();
  ReadIniFile();
  ReadPreferences();
  InitlzUI();
  LayoutUI();
}

//-------------------------------------
void InitlzUI() {
  winx = (wxp*maxx)/100;
  winy = (wyp*maxy)/100;
  uif = new Font(uifn, Font.BOLD, uifs);
  Util.PutUIManFonts(uif);
  taf = new Font(tafn, Font.PLAIN, tafs);
  sbar = new JButton(stxt);
  sbar.setFont(uif);
  sbar.addActionListener(new CBButton());
  sbar.addKeyListener(new CBKey());
  sbar.setBackground(new Color(0.5f, 0.1f, 0.1f));
  sbar.setForeground(new Color(1.0f, 1.0f, 0.1f));
  InitlzUITextArea();
  InitlzUIResources();
}

//-------------------------------------
void InitlzUIResources() {
Image       iimg;
Toolkit     tk;
URL         iurl;
  tk = Toolkit.getDefaultToolkit();
  iurl = mf.getClass().getResource("/jtxt.png");
  iimg = tk.createImage(iurl);
  setIconImage(iimg);
}

//-------------------------------------
void InitlzUITextArea() {
Dimension   dim;
JScrollBar  jsb;
  txta = new JTextArea();
  txta.addKeyListener(new CBKey());
  txta.setFont(taf);
  txta.setBackground(new Color(0xFFFFFF));
  txta.setLineWrap(true);
  txta.setWrapStyleWord(true);
  txta.setTabSize(2);
  txta.addCaretListener(new CBPosition());
  txta.getDocument().addDocumentListener(new CBModified());
  spta = new JScrollPane(txta);
  spta.setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_NEVER);
  spta.setVerticalScrollBarPolicy(ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS);
  jsb = spta.getVerticalScrollBar();
  dim = jsb.getPreferredSize();
  dim.width *=2;
  jsb.setPreferredSize(dim);
}

//-------------------------------------
void InitlzVars() {
  uifn = Font.SERIF;
  uifs = UIFSIZ;
  tafn = Font.MONOSPACED;
  tafs = TAFSIZ;
  wxp = WXP;
  wyp = WYP;
  nsav = false;
  wdir = DEFDIR;
  selb = -1;
  sele = -1;
  stxt = "Click Here";
}

//-------------------------------------
public jtxt(String[] args) {
Dimension dim;
Toolkit   tk;
  tk = Toolkit.getDefaultToolkit();
  dim = tk.getScreenSize();
  maxx = dim.width;
  maxy = dim.height;
  if (args.length>0) fto = args[0];
  else fto = "";
}

//-------------------------------------
void LayoutUI() {
  addWindowListener(this);
  mf.addKeyListener(new CBKey());
  mf.addComponentListener(new CBResize());
  mf.setLocation((maxx-winx)/2, 0);
  mf.setSize(winx, winy);
  mf.getContentPane().add(sbar, BorderLayout.NORTH);
  mf.getContentPane().add(spta, BorderLayout.CENTER);
  mf.setTitle("jtxt");
  mf.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
  mf.setVisible(true);
}

//-------------------------------------
public static void main(String[] args) {
  mf = new jtxt(args);
  mf.Initlz();
}

//-------------------------------------
void OpenFile() {
String txt;
  txt = Util.ReadTextFile(fil, mf);
  txta.setText(txt);
  txta.setCaretPosition(0);
  txta.requestFocusInWindow();
  txt = fil.getName();
  mf.setTitle(txt);
  nsav = false;
}

//-------------------------------------
void PopupMain() {
JMenuItem     mi;
JPopupMenu    pum;
  pum = new JPopupMenu();
  mi = new JMenuItem("File");
  mi.setMnemonic('F');
  mi.addActionListener(new AFile());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("Edit");
  mi.setMnemonic('E');
  mi.addActionListener(new AEdit());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("Search");
  mi.setMnemonic('S');
  mi.addActionListener(new ASearch());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("Utility");
  mi.setMnemonic('U');
  mi.addActionListener(new AUtility());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("Minimize");
  mi.setMnemonic('M');
  mi.addActionListener(new AMinimize());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("Quit");
  mi.setMnemonic('Q');
  mi.addActionListener(new AQuit());
  mi.setFont(uif);
  pum.add(mi);
  pum.show(mf, 0, 0);
}

//-------------------------------------
void ReadIniFile() {
BufferedReader  br;
Charset         cs;
File            inif;
Path            ifp;
String          jini, line, nam, val;
String[]        sa;
  jini = System.getenv("JINI")+"jtxt.ini";
  inif = new File(jini);
  if (!inif.exists()) {
    stxt = "no ini file";
    return;
  }
  ifp = inif.toPath();
  cs = Charset.forName("US-ASCII");
  try {
    br = Files.newBufferedReader(ifp, cs);
    while ((line = br.readLine()) != null) {
      sa = line.split("=");
      if (sa.length==2) {
        nam = sa[0];
        val = sa[1];
        if (nam.compareTo(UIFNLIT)==0) uifn = val;
        if (nam.compareTo(UIFSLIT)==0) uifs = Integer.parseInt(val);
        if (nam.compareTo(TAFNLIT)==0) tafn = val;
        if (nam.compareTo(TAFSLIT)==0) tafs = Integer.parseInt(val);
        if (nam.compareTo(WXPLIT)==0) wxp = Integer.parseInt(val);
        if (nam.compareTo(WYPLIT)==0) wyp = Integer.parseInt(val);
      }
    }
  } catch (Exception x) { System.err.format("Exception: %s%n", x); }
}

//-------------------------------------
void ReadPreferences() {
Preferences p;
  try {
    p = Preferences.userRoot().node(getClass().getName());
    wdir = p.get(DIRKEY, DEFDIR);
  } catch (Exception x) { Util.DspMsg(x.toString(), mf); }
}

//-------------------------------------
void SaveFile() {
BufferedWriter  bw;
FileWriter      fw;
String          txt;
  if (fil==null) fil = GetFileToSave();
  if (fil==null) return;
  txt = txta.getText();
  Util.SaveTextFile(fil, txt, mf);
  nsav = false;
  txt = fil.getName();
  mf.setTitle(txt);
  txta.requestFocusInWindow();
}

//-------------------------------------
boolean SearchNext() {
Highlighter      hl;
HighlightPainter hlp;
int              from, pos, ss, se;
String           fc;
  fc = txta.getText();
  fc = fc.toLowerCase();
  from = txta.getCaretPosition();
  pos = fc.indexOf(fnds, from);
  if (pos==-1) return(false);
  txta.setCaretPosition(pos);
  ss = pos;
  se = pos + fnds.length();
  txta.select(ss,se);
  txta.requestFocusInWindow();
  hl = txta.getHighlighter();
  hlp = new DefaultHighlighter.DefaultHighlightPainter(Color.pink);
  try {
    hl.removeAllHighlights();
    hl.addHighlight(ss, se, hlp);
  } catch (Exception x) { Util.DspMsg(x.toString(), mf); }
  return(true);
}

//-------------------------------------
void SetPreferences() {
Preferences p;
  p = Preferences.userRoot().node(getClass().getName());
  p.put(DIRKEY, wdir);
}

//-------------------------------------
public void windowActivated(WindowEvent e) {}
public void windowDeactivated(WindowEvent e) {}
public void windowDeiconified(WindowEvent e) {}
public void windowIconified(WindowEvent e) { if (nsav) SaveFile(); }
public void windowClosing(WindowEvent e) { if (nsav) SaveFile(); }
public void windowClosed(WindowEvent e) {}
public void windowOpened(WindowEvent e) { 
  if (fto.length()>0) {
    fil = new File(fto);
    wdir = fil.getPath();
    SetPreferences();
    OpenFile(); 
  }
}

//-------------------------------------
}
